source: trunk/debathena/scripts/installer/install-debathena.beta.sh @ 25839

Revision 25839, 19.3 KB checked in by jdreed, 11 years ago (diff)
* Deal with HWE LTS kernels whose source is not linux-meta * Preseed the cyrus-common question, which is meaningless for most people, and will go away in Dec 2013 anyway
Line 
1#!/bin/sh
2# Athena installer script.
3# Maintainer: debathena@mit.edu
4# Based on original Debathena installer script by: Tim Abbott <tabbott@mit.edu>
5
6# Download this to a Debian or Ubuntu machine and run it as root.  It can
7# be downloaded with:
8#   wget -N http://debathena.mit.edu/install-debathena.sh
9
10set -e
11
12# The user's umask will sometimes carry over; don't let that happen.
13umask 022
14
15output() {
16  printf '\033[38m'; echo "$@"; printf '\033[0m'
17}
18
19error() {
20  printf '\033[31m'; echo "$@"; printf '\033[0m'
21}
22
23ask() {
24  answer=''
25  while [ y != "$answer" -a n != "$answer" ]; do
26    printf '\033[38m'; echo -n "$1"; printf '\033[0m'
27    read answer
28    [ Y = "$answer" ] && answer=y
29    [ N = "$answer" ] && answer=n
30    [ -z "$answer" ] && answer=$2
31  done
32  output ""
33}
34
35if [ `id -u` != "0" ]; then
36  error "You must run the Debathena installer as root."
37  if [ -x /usr/bin/sudo ]; then
38    error "Try running 'sudo $0'."
39  fi
40  exit 1
41fi
42
43pxetype=
44if test -f /root/pxe-install-flag ; then
45  pxetype=`head -1 /root/pxe-install-flag`
46fi
47
48have_lsbrelease="$(dpkg-query -W -f '${Status}' lsb-release 2>/dev/null)"
49if [ "$have_lsbrelease" != "install ok installed" ]; then
50  echo "The installer requires the 'lsb-release' package to determine"
51  echo "whether or not installation can proceed."
52  ask "Is it ok to install this package now? [Y/n] " y
53  if [ y = "$answer" ]; then
54    if ! apt-get -qq update && apt-get -qqy install lsb-release; then
55        error "Could not install lsb-release.  Try installing it manually."
56        exit 1
57    fi
58  else
59    error "Sorry, lsb-release is required.  Cannot continue."
60    exit 1
61  fi
62fi
63distro=`lsb_release -cs`
64aptitude=aptitude
65case $distro in
66  squeeze)
67    ;;
68  hardy|lucid)
69    ubuntu=yes
70    ;;
71  oneiric|precise|quantal)
72    ubuntu=yes
73    aptitude=apt-get
74    ;;
75  raring)
76    ubuntu=yes
77    aptitude=apt-get
78    output "The release you are running ($distro) is not yet supported"
79    output "and installing Debathena on it is probably a bad idea,"
80    output "particularly for any purpose other than beta testing."
81    output ""
82    output "(New releases are generally supported a couple of weeks"
83    output "after the official release date.  We strongly encourage you"
84    output "to check http://debathena.mit.edu for support information"
85    output "and try again later, or install the previous version of"
86    output "the operating system.)"
87    if ! test -f /root/pxe-install-flag; then
88        ask "Are you sure you want to proceed? [y/N] " n
89        [ y != "$answer" ] && exit 1
90    fi
91    ;;
92  lenny|intrepid|jaunty|karmic|maverick|natty)
93    error "The release you are running ($distro) is no longer supported."
94    error "Generally, Debathena de-supports releases when they are no longer"
95    error "supported by upstream.  If you believe you received this message"
96    error "in error, please contact debathena@mit.edu."
97    exit 1
98    ;;
99  *)
100    error "Unsupported release codename: $distro"
101    error "Sorry, Debathena does not support installation on this release at this time."
102    error "(New releases may not be supported immediately after their release)."
103    error "If you believe you are running a supported release or have questions,"
104    error "please contact debathena@mit.edu"
105    exit 1
106    ;;
107esac
108
109laptop=no
110wifi=no
111if [ -x /usr/sbin/laptop-detect ] && /usr/sbin/laptop-detect 2>/dev/null; then
112    laptop=yes
113fi
114
115if [ -x /usr/bin/nmcli ] && /usr/bin/nmcli dev status 2>/dev/null | awk '{print $2}' | grep -q 802-11-wireless; then
116    wifi=yes
117fi
118
119echo "Welcome to the Debathena installer."
120echo ""
121echo "Please choose the category which best suits your needs.  Each category"
122echo "in this list includes the functionality of the previous ones.  See the"
123echo "documentation at http://debathena.mit.edu for more information."
124echo ""
125echo "  standard:        Athena client software and customizations"
126echo "                   Recommended for laptops and single-user computers."
127echo "  login:           Allow Athena accounts to log into your machine"
128echo "                   Recommended for private remote-access servers."
129echo "  login-graphical: Athena graphical login customizations"
130echo "                   Recommended for private multi-user desktops."
131echo "  workstation:     Graphical workstation with automatic updates"
132echo "                   Recommended for auto-managed cluster-like systems."
133echo ""
134
135if [ "$laptop" = "yes" ] || [ "$wifi" = "yes" ]; then
136    cat <<EOF
137This machine appears to be a laptop or has at least one wireless
138network device.  You probably want to choose "standard" unless this
139device will have an uninterrupted network connection.
140EOF
141fi
142
143category=""
144if [ cluster = "$pxetype" ] ; then
145  category=cluster ;
146  echo "PXE cluster install detected, so installing \"cluster\"."
147fi
148while [ standard != "$category" -a login != "$category" -a \
149        login-graphical != "$category" -a workstation != "$category" -a \
150        cluster != "$category" ]; do
151  output -n "Please choose a category or press control-C to abort: "
152  read category
153done
154
155if [ cluster = "$category" ]; then
156  # We still want these set for cluster installs, which should be truly
157  # noninteractive
158  export DEBCONF_NONINTERACTIVE_SEEN=true
159  export DEBIAN_FRONTEND=noninteractive
160fi
161
162mainpackage=debathena-$category
163
164csoft=no
165tsoft=no
166resolvconfhack=no
167echo "The extra-software package installs a standard set of software"
168echo "determined to be of interest to MIT users, such as LaTeX.  It is pretty"
169echo "big (several gigabytes, possibly more)."
170echo ""
171echo "Note: This package may include software with additional license terms."
172echo "      By installing it, you are agreeing to the terms of these licenses."
173echo "      For more information, please see http://debathena.mit.edu/licensing"
174echo ""
175if [ cluster = $category -o workstation = $category ] ; then
176  # See Trac #648 and LP:471975
177  resolvconfhack=yes
178  echo "The extra-software package is required for '$category' and will be installed."
179  csoft=yes
180  # Not setting tsoft=yes here; -cluster will pull it in anyway.
181else
182  ask "Do you want the extra-software package [y/N]? " n
183  if [ y = "$answer" ]; then
184    csoft=yes
185  fi
186fi
187if [ yes = "$csoft" ]; then
188    # Preseed an answer to the java license query, which license was already accepted
189    # at install time:
190    echo "sun-java6-bin shared/accepted-sun-dlj-v1-1 boolean true" |debconf-set-selections
191fi
192
193if [ "$(cat /sys/class/dmi/id/product_name)" = "OptiPlex 790" ] && \
194    dpkg --compare-versions "$(uname -r)" lt 3.2~; then
195    noacpi=y
196    if [ "$category" != "cluster" ]; then
197        echo
198        echo "The Dell 790 sometimes has problems rebooting.  The best way to"
199        echo "work around this is to pass 'reboot=pci' at boot time."
200        echo "This change will be made in your GRUB (bootloader) configuration."
201        ask "Is it ok to do this now? [Y/n] " y
202        if [ y != "$answer" ]; then
203            noacpi=n
204        fi
205    fi
206    if [ "$noacpi" = "y" ] && ! grep -q "Added by install-debathena.sh to address reboot issues on the Dell 790" /etc/default/grub; then
207        cat >> /etc/default/grub << 'EOF'
208
209# Added by install-debathena.sh to address reboot issues on the Dell 790
210GRUB_CMDLINE_LINUX="reboot=pci $GRUB_CMDLINE_LINUX"
211EOF
212        update-grub
213    fi
214fi
215
216echo "A summary of your choices:"
217echo "  Category: $category"
218echo "  Extra-software package: $csoft"
219echo "  Third-party software package: $tsoft"
220echo ""
221if [ "$pxetype" = "cluster" ] ; then
222  if wget -q http://athena10.mit.edu/installer/installing.txt; then
223     cat installing.txt > /dev/tty6
224     date > /dev/tty6
225     chvt 6
226     rm installing.txt
227  fi
228  # Divert the default background and install our own so that failed machines
229  # are more conspicuous
230  echo "Diverting default background..."
231  bgimage=/usr/share/backgrounds/warty-final-ubuntu.png
232  divertedbg=no
233  if dpkg-divert --divert ${bgimage}.debathena --rename $bgimage; then
234      divertedbg=yes
235      if ! wget -N -O $bgimage http://debathena.mit.edu/error-background.png; then
236          echo "Hrm, that didn't work.  Oh well..."
237          dpkg-divert --rename --remove $bgimage
238          divertedbg=no
239      fi
240  fi
241
242  # Setup for package installs in a chrooted immediately-postinstall environment.
243  echo "Setting locale."
244  export LANG
245  . /etc/default/locale
246  echo "LANG set to $LANG."
247  echo "Mounting /proc."
248  mount /proc 2> /dev/null || :
249  # Clear toxic environment settings inherited from the installer.
250  unset DEBCONF_REDIR
251  unset DEBIAN_HAS_FRONTEND
252  if [ cluster = "$pxetype" ] ; then
253    # Network, LVM, and display config that's specific to PXE cluster installs.
254    # If someone is installing -cluster on an already-installed machine, it's
255    # assumed that this config has already happened and shouldn't be stomped on.
256
257    # Configure network based on the preseed file settings, if present.
258    if test -f /root/debathena.preseed && ! grep -q netcfg/get_ipaddress /proc/cmdline; then
259      # Switch to canonical hostname.
260      ohostname=`cat /etc/hostname`
261      # Hack to avoid installing debconf-get for just this.
262      ipaddr=`grep netcfg/get_ipaddress /root/debathena.preseed|sed -e 's/.* //'`
263      netmask=`grep netcfg/get_netmask /root/debathena.preseed|sed -e 's/.* //'`
264      gateway=`grep netcfg/get_gateway /root/debathena.preseed|sed -e 's/.* //'`
265
266      hostname=`host $ipaddr | \
267          sed 's#^.*domain name pointer \(.*\)$#\1#' | sed 's;\.*$;;' | \
268          tr '[A-Z]' '[a-z]'`
269      if echo $hostname|grep -q "not found" ; then
270        hostname=""
271        printf "\a"; sleep 1 ; printf "\a"; sleep 1 ;printf "\a"
272        echo "The IP address you selected, $ipaddr, does not have an associated"
273        echo "hostname.  Please confirm that you're using the correct address."
274        while [ -z "$hostname" ] ; do
275          echo -n "Enter fully qualified hostname [no default]: "
276          read hostname
277        done
278      fi
279      echo ${hostname%%.*} > /etc/hostname
280      sed -e 's/\(127\.0\.1\.1[         ]*\).*/\1'"$hostname ${hostname%%.*}/" < /etc/hosts > /etc/hosts.new
281      mv -f /etc/hosts.new /etc/hosts
282      if grep -q dhcp /etc/network/interfaces ; then
283        sed -e s/dhcp/static/ < /etc/network/interfaces > /etc/network/interfaces.new
284        echo "  address $ipaddr" >> /etc/network/interfaces.new
285        echo "  netmask $netmask" >> /etc/network/interfaces.new
286        echo "  gateway $gateway" >> /etc/network/interfaces.new
287        echo "  dns-nameservers 18.72.0.3 18.70.0.160 18.71.0.151" >> /etc/network/interfaces.new
288        mv -f /etc/network/interfaces.new /etc/network/interfaces
289      fi
290      hostname ${hostname%%.*}
291    fi
292
293  fi
294else
295  output "Press return to begin or control-C to abort"
296  read dummy
297fi
298
299# Set the "seen" flag for all debconf questions that we configure
300# cluster is still non-interactive, see above.
301# Except you can't set the "seen" flag for something that isn't installed
302# so also set some sane defaults
303cat <<EOF | debconf-set-selections
304# Set sane defaults
305openafs-client  openafs-client/thiscell string grand.central.org
306openafs-client  openafs-client/cachesize string 150000
307cyrus-common    cyrus-common/removespools       boolean false
308# A null value is fine as of krb5 1.6.dfsg.3-1
309krb5-config     krb5-config/default_realm string
310# No value means use Hesiod
311zephyr-clients  zephyr-clients/servers string
312# Then mark them as seen
313openafs-client  openafs-client/thiscell seen true
314openafs-client  openafs-client/cachesize seen true
315krb5-config     krb5-config/default_realm seen true
316zephyr-clients  zephyr-clients/servers seen true
317# These are also questions asked by default, but
318# the user should probably see them anyway.
319#gdm     shared/default-x-display-manager seen true
320cyrus-common    cyrus-common/removespool seen true
321#hddtemp hddtemp/daemon seen true
322EOF
323
324apt-get update
325
326output "Verifying machine is up to date..."
327pattern='^0 upgraded, 0 newly installed, 0 to remove'
328if ! apt-get --simulate --assume-yes dist-upgrade | grep -q "$pattern"; then
329    if [ -n "$pxetype" ] ; then
330        output "Forcing an upgrade"
331        apt-get --assume-yes dist-upgrade
332    else
333        error "Your system is not up to date.  Proceeding with an install at"
334        error "this time could render your system unusable."
335        error "Please run 'apt-get dist-upgrade' as root or use the GUI update"
336        error "manager to ensure your system is up to date before continuing."
337        error "NOTE: You do NOT need to upgrade to a newer release of Ubuntu",
338        error "you merely need to ensure you have the latest software updates"
339        error "for the current version."
340        exit 1
341    fi
342fi
343
344if ! hash aptitude >/dev/null 2>&1; then
345  output "Installing Debathena installer dependency: aptitude"
346  apt-get -y install aptitude
347fi
348
349output "Installing Debathena installer dependencies: wget and dnsutils"
350apt-get -y install wget dnsutils
351if [ yes = "$resolvconfhack" ]; then
352  output "Installing resolvconf ahead of time"
353  apt-get -y install resolvconf
354fi
355
356# Only add our openafs component if DKMS isn't available
357openafs_component=""
358if aptitude show openafs-modules-dkms > /dev/null; then
359  modules="openafs-modules-dkms"
360else
361  openafs_component=" openafs"
362fi
363
364# Select the correct headers package
365kernel_hdr_meta_pkgs=
366if [ "$ubuntu" = "yes" ]; then
367    # Ubuntu kernel metapackages have a source of 'linux-meta'
368    # Find all of them and replace "-image-" with "-headers-".
369    # Except the source _starts with_ linux-meta because of HWE
370    # stacks (e.g. linux-meta-lts-quantal.  I hate you all.
371    kernel_hdr_meta_pkgs=$(dpkg-query -W -f '${Source}\t${Package}\n' 'linux-image-*' | awk '$1 ~ /^linux-meta/ { sub(/-image-/, "-headers-", $2); print $2 }')
372else
373    # Debian.  "Yay".  Old squeeze has linux-latest-2.6 as the
374    # metapackage.  squeeze-backpors and newer have linux-latest as
375    # the metpackage.  For bonus points, wheezy can have two packages
376    # installed with linux-latest as the metapackage, because one of
377    # those is itself a metapckage.
378    kernel_hdr_meta_pkgs=$(dpkg-query -W -f '${Source}::${Package}\n' 'linux-image-*' | awk -F:: '$1~/^linux-latest/ { sub(/-image-/, "-headers-", $2); print $2 }')
379fi
380pkgs_to_install=
381for p in $kernel_hdr_meta_pkgs; do
382    # Only install real packages
383    if apt-cache show $p | grep -q '^Source: '; then
384        pkgs_to_install=" $p"
385    fi
386done
387if [ -z "$pkgs_to_install" ]; then
388    output "We cannot find a kernel header metapackage for your kernel."
389    output "You will need one in order for DKMS to build the openafs"
390    output "kernel module.  You should probably stop here and figure out"
391    output "what kernel metapackage you're running, and install the"
392    output "corresponding kernel headers package."
393    ask "Do you want to continue anyway? [y/N] " n
394    if [ y != "$answer" ]; then
395        exit 0
396    fi
397else
398    output "Installing header packages: $pkgs_to_install"
399    apt-get -y install $pkgs_to_install
400fi
401
402output "Adding the Debathena repository to the apt sources"
403output "(This may cause the update manager to claim new upgrades are available."
404output "Ignore them until this script is complete.)"
405sourceslist=/etc/apt/sources.list.d/debathena.list
406clustersourceslist=/etc/apt/sources.list.d/debathena.clusterinfo.list
407if [ -z "$hostname" ] ; then hostname=`hostname` ; fi
408
409if [ ! -e "$sourceslist" ] || ! grep -v ^# "$sourceslist" | grep -q debathena; then
410  if [ -e "$sourceslist" ]; then
411    echo "" >> $sourceslist
412  fi
413  echo "deb http://debathena.mit.edu/apt $distro debathena debathena-config debathena-system$openafs_component" >> $sourceslist
414  echo "deb-src http://debathena.mit.edu/apt $distro debathena debathena-config debathena-system$openafs_component" >> $sourceslist
415fi
416
417# As of 6 March 2013, Hesiod no longer contains multiple unversioned
418# apt_release tokens (Trac: #1036).  development implies proposed.
419# bleeding implies development, and the transitive property applies.
420# It's possible we should have this be configurable via a URL
421# rather than hardcoded.
422apt_release=$(dig +short +bufsize=2048 ${hostname}.cluster.ns.athena.mit.edu TXT | tr -d '"' | awk '$1=="apt_release" { print $2 }')
423
424if [ -n "$apt_release" ]; then
425  extra_repos=
426  case "$apt_release" in
427    development)
428      extra_repos="development proposed" ;;
429    proposed)
430      extra_repos="proposed" ;;
431    bleeding)
432      extra_repos="bleeding development proposed" ;;
433    *)
434      output "NOTE: Ignoring unknown apt_release value: \"$apt_release\"" ;;
435  esac
436  aptexplained=false
437  for hc in $extra_repos; do
438    echo "Adding $distro-$hc apt repository."
439    if [ "${aptexplained}" = false ] ; then
440      echo "" >> $clustersourceslist
441      echo "# This file is automatically updated by debathena-auto-update" >> $clustersourceslist
442      echo "# based on your Hesiod cluster information. If you want to" >> $clustersourceslist
443      echo "# make changes, do so in another file." >> $clustersourceslist
444      aptexplained=true
445    fi
446    echo "" >> $clustersourceslist
447    echo "deb http://debathena.mit.edu/apt $distro-${hc} debathena debathena-config debathena-system$openafs_component" >> $clustersourceslist
448    echo "deb-src http://debathena.mit.edu/apt $distro-${hc} debathena debathena-config debathena-system$openafs_component" >> $clustersourceslist
449  done
450fi
451
452if [ "$ubuntu" = "yes" ]; then
453  output "Making sure the universe repository is enabled"
454  sed -i 's,^# \(deb\(\-src\)* http://archive.ubuntu.com/ubuntu [[:alnum:]]* universe\)$,\1,' /etc/apt/sources.list
455fi
456
457output "Downloading the Debathena archive signing key"
458if ! wget -N http://debathena.mit.edu/apt/debathena-archive-keyring.asc ; then
459  error "Download failed; terminating."
460  exit 1
461fi
462echo "fa787714d1ea439c28458aab64962f755e2bdee7a3520919a72b641458757fa3586fd269cc1dae8d99047e00b3df88db0826f0c99a1f5a8771618b3c0be8e3bd  ./debathena-archive-keyring.asc" | \
463  sha512sum -c
464apt-key add debathena-archive-keyring.asc
465rm ./debathena-archive-keyring.asc
466
467$aptitude update
468
469if [ -z "$modules" ]; then
470  modules_want=$(dpkg-query -W -f '${Source}\t${Package}\n' 'linux-image-*' | \
471   sed -nre 's/^linux-(meta|latest[^\t]*)\tlinux-image-(.*)$/openafs-modules-\2/p')
472  modules=
473  for m in $modules_want; do
474    aptitude show $m > /dev/null && modules="$modules $m"
475  done
476fi
477
478if [ -z "$modules" ]; then
479  error "An OpenAFS modules metapackage for your kernel is not available."
480  error "Please use the manual installation instructions at"
481  error "http://debathena.mit.edu/install"
482  error "You will need to compile your own AFS modules as described at:"
483  error "http://debathena.mit.edu/troubleshooting#openafs-custom"
484  exit 1
485fi
486
487output "Installing OpenAFS kernel metapackage"
488apt-get -y install $modules
489
490if [ "cluster" = "$category" ] || [ "workstation" = "$category" ] ; then
491    output "Installing debathena-license-config"
492    apt-get -y install debathena-license-config
493fi
494
495# Use the noninteractive frontend to install the main package.  This
496# is so that AFS and Zephyr don't ask questions of the user which
497# debathena packages will later stomp on anyway.
498output "Installing main Debathena metapackage $mainpackage"
499
500$aptitude -y install "$mainpackage"
501
502# Use the default front end and allow questions to be asked; otherwise
503# Java will fail to install since it has to present its license.
504if [ yes = "$csoft" ]; then
505  output "Installing debathena-extra-software"
506  DEBIAN_PRIORITY=critical $aptitude -y install debathena-extra-software
507fi
508if [ yes = "$tsoft" ]; then
509  output "Installing debathena-thirdparty"
510  DEBIAN_PRIORITY=critical $aptitude -y install debathena-thirdparty
511fi
512
513# Post-install cleanup for cluster systems.
514if [ "$divertedbg" = "yes" ]; then
515    rm -f $bgimage
516    if ! dpkg-divert --rename --remove $bgimage; then
517        echo "Failed to remove diversion of background.  You probably don't care."
518    fi
519fi
520
521if [ cluster = "$category" ] ; then
522  # Force an /etc/adjtime entry so there's no confusion about whether the
523  # hardware clock is UTC or local.
524  echo "Setting hardware clock to UTC."
525  hwclock --systohc --utc
526fi
Note: See TracBrowser for help on using the repository browser.